<?php

/**
 * Class NewTrustedShopsModuleCenterModule
 */
class NewTrustedShopsModuleCenterModule extends AbstractModuleCenterModule
{
    /**
     * Init
     */
    protected function _init()
    {
        $this->title       = $this->languageTextManager->get_text('new_trustedshops_module_center_title');
        $this->description = $this->languageTextManager->get_text('new_trustedshops_module_center_description');
        $this->sortOrder   = 99999;

        $cacheControl    = MainFactory::create('CacheControl');

        $cacheControl->clear_cache();
        $cacheControl->clear_content_view_cache();
        $cacheControl->clear_templates_c();
        $cacheControl->clear_template_cache();
        $cacheControl->clear_google_font_cache();
        $cacheControl->clear_css_cache();
        $cacheControl->clear_expired_shared_shopping_carts();
        $cacheControl->remove_reset_token();
    }

    /**
     * Install the module and clear the cache
     */
    public function install()
    {
        parent::install();

        $cacheControl    = MainFactory::create('CacheControl');

        $cacheControl->clear_cache();
        $cacheControl->clear_content_view_cache();
        $cacheControl->clear_templates_c();
        $cacheControl->clear_template_cache();
        $cacheControl->clear_google_font_cache();
        $cacheControl->clear_css_cache();
        $cacheControl->clear_expired_shared_shopping_carts();
        $cacheControl->remove_reset_token();

        $phraseCacheBuilder = MainFactory::create_object('PhraseCacheBuilder', []);
        $phraseCacheBuilder->build();

        $cacheControl->clear_data_cache();

        $this->db->query("CREATE TABLE IF NOT EXISTS `trustedshops_configuration` (
                              `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                              `trustedshops_locale` varchar(50) DEFAULT NULL,
                              `trustedshops_id` varchar(50) DEFAULT NULL,
                              `trustbadge_code` text,
                              `trustbadge_active` tinyint(4) NOT NULL DEFAULT '0',
                              `shop_review_code` text,
                              `shop_review_active` tinyint(4) NOT NULL DEFAULT '0',
                              `collect_product_reviews` tinyint(4) NOT NULL DEFAULT '0',
                              `product_review_code` text,
                              `product_review_active` tinyint(4) NOT NULL DEFAULT '0',
                              `product_review_stars_code` text,
                              `product_review_stars_active` tinyint(4) NOT NULL DEFAULT '0',
                              PRIMARY KEY (`id`)
                            ) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;");

        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Admin/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Admin/Html/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Admin/JavaScript/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Admin/Styles/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Admin/Classes/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Admin/TextPhrases/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Shop/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Shop/Overloads/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Shop/Templates/', 0755);
        chmod(DIR_FS_CATALOG . 'GXModules/TrustedShopsAktuell/TrustedShopsAktuell/Shop/Themes/', 0755);


        if($_SESSION['trustedshops_locale'] === NULL) {
            $_SESSION['trustedshops_locale'] = 'de';
        }
    }

    /**
     * Uninstall the module and clear the storage
     */
    public function uninstall()
    {
        $this->db->query("DROP TABLE IF EXISTS `trustedshops_configuration`");

        parent::uninstall();
    }
}
